//+------------------------------------------------------------------+
//|                                                         SATL.mq4 |
//|                                                          Valmars |
//|                                         valmars@mail.primorye.ru |
//+------------------------------------------------------------------+
#property copyright "Valmars"
#property link      "valmars@mail.primorye.ru"
#include <stdlib.mqh>
#include <stderror.mqh>
//---- input parameters
extern int TakeProfit = 100;
extern int StopLoss = 65;
extern string _Param_Trailing_ = " ---  - ---";
extern bool UseTrailing = true;
extern int MinProfit = 70;
extern int TrailingStop = 65;
extern int TrailingStep = 1;
extern int Body=70; // Min    
extern double Lots = 1.0;
extern int moda=0; 
extern double risk=10; 
extern double PercentFreeMargin=50;
extern int Period_X=1440;
extern int MaxOrders = 3;
datetime TimeOpen;
bool Finish=False;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
void start() 
 {
  int      i,ticket,cmd,total,slippage=5,type,profit,FreeMargin,MarginLevel;
  double   vol;
  string symbol = Symbol(),name=""; 
  int BuyCnt,SellCnt,LimitCnt;
if (UseTrailing)TrailingPositions(symbol,MinProfit,TrailingStop,TrailingStep);
//----------------------------------------------------------------------------------------------------------------
//    
//----------------------------------------------------------------------------------------------------------------
if (Finish)return;
if (NewBar(PERIOD_D1))   //  PERIOD_D1
 { 
   total=OrdersTotal(); 
   for (i=0;i<total;i++)       
	 { 	
     if (!(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))) 
      {
       int error_code = GetLastError();
       Print("Error OrderSelect function: ", ErrorDescription(error_code), " (", error_code, ")");
       return ;
      }
	  if ( OrderSymbol()!=symbol)     	
		continue;                        
  	  else
  	   {
	      if (type == OP_BUY) BuyCnt++;    //    
         if (type == OP_SELL) SellCnt++;
         if ((OrderType()==OP_BUYSTOP && (OrderOpenPrice()-Ask)/Point>MarketInfo(symbol,MODE_FREEZELEVEL)) ||
	          (OrderType()==OP_SELLSTOP && (Bid-OrderOpenPrice())/Point>MarketInfo(symbol,MODE_FREEZELEVEL)))
	       {OrderDelete(OrderTicket());Sleep(10000);} //  
      }
	 } //  for  
if (AccountFreeMargin( ) < 1000)return; //{Finish=true;Print("Finit a la komedia");return;}
if (OrdersTotal()>=MaxOrders)return;
cmd=OP_BUY;
            vol=LotsCalculate(symbol,cmd,Lots,risk,moda,PercentFreeMargin);
			   if (vol-MarketInfo(symbol,MODE_MINLOT)<0)
			    return; 
if ((iOpen(symbol,PERIOD_D1,1) -iClose(symbol,PERIOD_D1,1))/Point-Body >0) //   
     {double OpenPrice=iHigh(symbol,PERIOD_D1,1);
      if (OpenPrice-Ask-MODE_STOPLEVEL*Point<0) OpenPrice=Ask+MODE_STOPLEVEL*Point;
       ticket=OrderSend(symbol,OP_BUYSTOP,vol,OpenPrice,5,OpenPrice-StopLoss*Point,OpenPrice+TakeProfit*Point,"",1, TimeCurrent()+23*3600 , Yellow); 
       if (ticket<=0)
        {error_code = GetLastError();
         Print("Error opening order : ", ErrorDescription(error_code), " (", error_code, ")");
        }
   	 Sleep(10000);RefreshRates();
       OpenPrice=iClose(symbol,PERIOD_D1,1);
       if (Bid-MODE_STOPLEVEL*Point-OpenPrice<0) OpenPrice=Bid-MODE_STOPLEVEL*Point;
       ticket=OrderSend(symbol,OP_SELLSTOP,vol,OpenPrice,5,OpenPrice+StopLoss*Point,OpenPrice-TakeProfit*Point,"",2, TimeCurrent()+23*3600 , Yellow); 
       if (ticket<=0)
        {error_code = GetLastError();
         Print("Error opening order : ", ErrorDescription(error_code), " (", error_code, ")");
        }
       Sleep(10000);RefreshRates();
      }
if ((iClose(symbol,PERIOD_D1,1) -iOpen(symbol,PERIOD_D1,1))/Point-Body >0) //   
     {OpenPrice=iClose(symbol,PERIOD_D1,1);
      
      if (OpenPrice-Ask-MODE_STOPLEVEL*Point<0) OpenPrice=Ask+MODE_STOPLEVEL*Point;
      OrderSend(symbol,OP_BUYSTOP,vol,OpenPrice,5,OpenPrice-StopLoss*Point,OpenPrice+TakeProfit*Point,"",3, TimeCurrent()+23*3600 , Yellow); 
      Sleep(10000);
      OpenPrice=iLow(symbol,PERIOD_D1,1);
      if (Bid-MODE_STOPLEVEL*Point-OpenPrice<0) OpenPrice=Bid-MODE_STOPLEVEL*Point;
      ticket=OrderSend(symbol,OP_SELLSTOP,vol,OpenPrice,5,OpenPrice+StopLoss*Point,OpenPrice-TakeProfit*Point,"",4, TimeCurrent()+23*3600 , Yellow); 
      if (ticket<=0)
        {error_code = GetLastError();
         Print("Error opening order : ", ErrorDescription(error_code), " (", error_code, ")");
        }
       Sleep(10000);RefreshRates();
     }      
 } //  NewBar  
return; 	
} // start() 
//+------------------------------------------------------------------+


bool NewBar(int Period_X)
   {
    bool result=false;
    if (TimeOpen!=iTime(NULL,Period_X,0))   // 
     {result=true;
      TimeOpen=iTime(NULL,Period_X,0);}
    return(result);
   }
double LotsCalculate(string symbol,int cmd,double Lots,double risk,int moda,double PercentFreeMargin)
   {
   double vol,FreeMargin,MarginLevel;
   if (moda !=0) 
   vol=MathCeil((AccountBalance()*risk/10000))/10; //   
   else
 	vol=Lots;
   if (vol>MarketInfo(symbol,MODE_MAXLOT))vol=MarketInfo(symbol,MODE_MAXLOT);
   if (vol<MarketInfo(symbol,MODE_MINLOT))vol=MarketInfo(symbol,MODE_MINLOT);
   while (AccountFreeMarginCheck(symbol,cmd,vol) < AccountEquity()*PercentFreeMargin/100)
    {
     if (vol<=MarketInfo(symbol,MODE_MINLOT)|| CalculateMarginLevel(vol) < AccountStopoutLevel())
     {
      MarginLevel=AccountEquity()/AccountMargin()*100;  
      Alert("     ",symbol,"\n",
      " FreeMargin= ", AccountFreeMargin(), " MarginLevel= ", MarginLevel, "%");return(0);}
     else
      {vol=vol-MarketInfo(symbol,MODE_LOTSTEP);} 
    }
return(vol);
   }
double CalculateMarginLevel(double vol)  //      vol 
 {return(AccountEquity()/(AccountMargin()+MarketInfo(Symbol(),MODE_MARGINREQUIRED)*vol)*100);}
//+------------------------------------------------------------------+
//|void TrailingPositions() function                                     |
//+------------------------------------------------------------------+
void TrailingPositions(string symbol,int MinProfit,int TrailingStop,int TrailingStep) 
{
  int cnt = OrdersTotal();

  for (int i=0; i<cnt; i++) {
    if (!(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))) 
      {int error_code = GetLastError();
  Print("Error OrderSelect function: ", ErrorDescription(error_code), " (", error_code, ")");
  return ;
      }
    if (OrderSymbol() !=symbol) continue;        

    if (OrderType() == OP_BUY) {
      if (MarketInfo( symbol, MODE_BID) -OrderOpenPrice() > MinProfit*MarketInfo( symbol, MODE_POINT)) {
        if (OrderStopLoss() < MarketInfo( symbol, MODE_BID)-(TrailingStop+TrailingStep)*MarketInfo( symbol, MODE_POINT)) {
        if (!OrderModify(OrderTicket(), OrderOpenPrice(), MarketInfo( symbol, MODE_BID)-TrailingStop*MarketInfo( symbol, MODE_POINT), OrderTakeProfit(), 0, Blue))
         {error_code = GetLastError();
  Print("Error modify order : ", ErrorDescription(error_code), " (", error_code, ")");
  Sleep(10000);RefreshRates( );
  return ;
          }  
        }
      }
    }

    if (OrderType() == OP_SELL) {
      if (OrderOpenPrice()-MarketInfo( symbol, MODE_ASK) > MinProfit*MarketInfo( symbol, MODE_POINT)) {
        if (OrderStopLoss() > MarketInfo( symbol, MODE_ASK)+(TrailingStop+TrailingStep)*MarketInfo( symbol, MODE_POINT) || OrderStopLoss() == 0) {
        if (!OrderModify(OrderTicket(), OrderOpenPrice(), MarketInfo( symbol, MODE_ASK)+TrailingStop*MarketInfo( symbol, MODE_POINT), OrderTakeProfit(), 0, Blue))
         {error_code = GetLastError();
  Print("Error modify order : ", ErrorDescription(error_code), " (", error_code, ")");
  Sleep(10000);RefreshRates( );
  return ;
         }
        }
      }
    }
  }
return ;
}    